/**
 * What the kobold was up to in the well and the cave.
 */
function HamletWellShared() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.drankWater = false;
    this.drowned = false;
    this.fell = false;

    this.metBoys = false;

    this.scrapedThigh = false;
    this.escapedClimb = false;
    this.escapedRope = false;

    this.basiliskMet = false; // Saw the basilisk
    this.basiliskFought = false; // Fought the basilisk
    this.basiliskKilled = false; // Killed the basilisk
    this.basiliskFriend = false; // Befriended the basilisk

    this.basiliskPetrified = false; // Got petrified by basilisk
    this.basiliskFucked = false; // Got fucked by basilisk
    this.basiliskPenetrated = false; // Got penetrated by basilisk
    this.basiliskEnjoyed = false; // Enjoyed getting fucked by basilisk

    this.basiliskFingerDislocated = false; // Dislocated a finger fighting the basilisk

    this.basiliskDominated = false; // Dominated basilisk
    this.basiliskPeed = false; // Peed on basilisk
    this.basiliskOral = false; // Sucked / licked by basilisk
    this.basiliskDomFucked = false; // Fucked basilisk

    this.basiliskMirror = false; // Petrified the basilisk using a mirror
    this.basiliskRode = false; // Whether or not the basilisk was ridden
    this.basiliskRodeCameInside = false; // Whether or not the basilisk came inside of the kobold after being ridden

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {HamletWellShared-stripped} well A HamletWellShared object, stripped of private members and all functions.
     */
    this.load = function (well) {
        if (!well) {
            that.load(new HamletWellShared());
            return;
        }
        that.drankWater = well.drankWater || false;
        that.drowned = well.drowned || false;
        that.fell = well.fell || false;


        that.metBoys = well.metBoys || false;
        if (!that.metBoys && global.kobold.history.getKey("HamletWell", "help")) {
            that.metBoys = true;
        }

        that.scrapedThigh = well.scrapedThigh || false;
        that.escapedClimb = well.escapedClimb || false;
        that.escapedRope = well.escapedRope || false;

        that.basiliskMet = well.basiliskMet || false;
        that.basiliskFought = well.basiliskFought || false;
        that.basiliskKilled = well.basiliskKilled || false;
        that.basiliskFriend = well.basiliskFriend || false;

        that.basiliskPetrified = well.basiliskPetrified || false;
        that.basiliskFucked = well.basiliskFucked || false;
        that.basiliskPenetrated = well.basiliskPenetrated || false;
        that.basiliskEnjoyed = well.basiliskEnjoyed || false;

        that.basiliskFingerDislocated = well.basiliskFingerDislocated || false;

        that.basiliskDominated = well.basiliskDominated || false;
        that.basiliskPeed = well.basiliskPeed || false;
        that.basiliskOral = well.basiliskOral || false;
        that.basiliskDomFucked = well.basiliskDomFucked || false;

        that.basiliskMirror = well.basiliskMirror || false;
        that.basiliskRode = well.basiliskRode || false;
        that.basiliskRodeCameInside = well.basiliskRodeCameInside || false;
    };
}
