/**
 * Shake section of the home scene.
 * @param {HomeController} controller The home controller.
 */
function HomeShake(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var masturbateId = "unsavedMasturbateButton";
    var sleepId = "unsavedSleepButton";

    var toMasturbate = new HomeMasturbate(ctrl);
    var toSleep = new HomeWetDream(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var male = ctrl.gender() === GenderEnum.MALE;
        var toReturn = `[p]
                            Startled, you hop to your feet and frantically begin to swat the ants off of you.
                            The ones you don't manage to wipe off with the first pass of your hand immediately bite down,
                            your system flooded by enough venom to drive a dragon wild.
                        [/p]
                        [p]
                            You take a few steps backwards, away from the ant-pouring mound, as you continue to remove more bugs from your body.
                            You swat one on your side with the flat of your hand, you pluck one off of your tail, and crush one of the insects making its way up your chest.
                            Just as you thought you were completely ant-free, one final specimen digs its mandibles into your back, 
                            before being smitten by your rightful wrath.
                        [/p]
                        [p]
                            The rest of the bugs retreat back into their anthill, dissuaded by the distance you've created between you and it.
                            While you've managed to overcome the ants themselves, the potent aphrodisiac inflicted by their bites courses through your veins.
                            In between your legs, 
                            your ${male ? `fully erect member twitches and throbs,` : `sopping wet slit is`} practically [b]begging[/b] for attention.
                            You are [b]so[/b] aroused that your knees are growing weak, the urge, no, the [b]need[/b] 
                            to ${male ? `jerk off` : `touch yourself`} intensifying with every passing moment.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the ant choice button.
     */
    function buildMasturbateChoice() {
        var disabled = ctrl.unsaved.shake.has() ? "disabled" : "";
        var isSelected = ctrl.unsaved.shake.get() === HomeShakeChoice.MASTURBATE;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${masturbateId}" ${disabled}>Masturbate</button>`;

        var tooltip = `Relieve yourself. You wouldn't be able to sleep like this anyway.`;
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the shake choice button.
     */
    function buildSleepChoice() {
        var disabled = ctrl.unsaved.shake.has() ? "disabled" : "";
        var isSelected = ctrl.unsaved.shake.get() === HomeShakeChoice.SLEEP;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${sleepId}" ${disabled}>Sleep</button>`;

        var tooltip = `Repress the dirty thoughts flooding your mind and try to get some rest.`;
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You: </div>`;
        choice += buildMasturbateChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSleepChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + masturbateId), $("#" + sleepId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerMasturbateListener() {
        $("#" + masturbateId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.unsaved.shake.set(HomeShakeChoice.MASTURBATE);
            loadNextPart(toMasturbate);
        });

    }

    /**
     * Adds a listener to the button.
     */
    function registerSleepListener() {
        $("#" + sleepId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.unsaved.shake.set(HomeShakeChoice.SLEEP);
            loadNextPart(toSleep);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "homeShake";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.unsaved.getGroundChoice() !== HomeGroundChoice.SHAKE) {
            return "";
        }
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += toMasturbate.build();
        part += toSleep.build();
        part += `</div>`;

        // BUILD CHILDREN HERE

        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.unsaved.getGroundChoice() !== HomeGroundChoice.SHAKE) {
            return;
        }

        toMasturbate.registerListeners();
        toSleep.registerListeners();

        if (ctrl.unsaved.shake.has()) {
            return;
        }

        registerMasturbateListener();
        registerSleepListener();
    };
}

var HomeShakeChoice = {
    MASTURBATE: 1,
    SLEEP: 2
};
