/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbide(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidMaidChoice.ABIDE;
    var reqController = ctrl.maid;
    var subController = ctrl.postMaid;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidPreAbsent(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You don't like this.
                            Getting fondled by a bird of questionable age,
                            while dressed up as a skimpy maid,
                            cleaning the house of the farmer that bought you.
                            But you can't stop him.
                            He's the [b]son[/b] of your master.
                            If you don't give him what he wants, he'll cry to his dad.
                            And who knows what Romeo might do to you then?
                            Torture you more?
                            [b]Kill[/b] you?
                        [/p]
                        [p]
                            You can't take that risk.
                            Even if that means getting fondled against your will.
                            You just have to let the avian sate his curiosity.
                            You're certain he'll back off after he's had a good feel or two.
                        [/p]
                        [p]
                            And a good feel he gets.
                            Falco wantonly squeezes your sensitive breasts with his feathery hands,
                            caressing your bosom through the thin, black fabric of your maid attire.
                            He slowly rolls his hips back and forth,
                            grinding his clothed package against your rear,
                            pleasuring his cock by squeezing it between your scaly butt and his thighs.
                        [/p]
                        [p]
                            For a moment, you think the boy is about to [b]rape[/b] you,
                            but then, as quickly as the unwanted fondling began,
                            it ends once more.
                            Suddenly, the bird lets go of you,
                            and before you can even ask him why the [b]hell[/b] he did that,
                            he [b]bolts[/b] up the stairs.
                            You can hear the door to his room opening, closing, and then locking.
                            You've a pretty good idea what he's doing in there.
                        [/p]
                        [p]
                            Anyway, you're glad it's over.
                            You [i]could[/i] go knock on his door and [b]demand[/b] an explanation,
                            but what's the point?
                            He got what he wanted,
                            and you get to live another day [b]without[/b] having your brains caved in for misbehaving.
                            You forget about the entire ordeal,
                            and continue with your day like nothing happened.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
