/**
 * Proposition section of Enslavement, Noon Two.
 * @param {SlaveNoonTwoController} controller The Enslavement, Noon Two controller.
 */
function SlaveNoonTwoSimpleOffer(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.offer;
    var changeController = ctrl.offer;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";
    var fourthId = arguments.callee.name + "ButtonFour";
    var fifthId = arguments.callee.name + "ButtonFive";
    var sixthId = arguments.callee.name + "ButtonSix";

    var firstNext = new SlaveNoonTwoGoodNothing(ctrl);
    var secondNext = new SlaveNoonTwoGoodDecline(ctrl);
    var thirdNext = new SlaveNoonTwoGoodInsult(ctrl);
    var fourthNext = new SlaveNoonTwoGoodAttack(ctrl);
    var fifthNext = new SlaveNoonTwoGoodReluctant(ctrl);
    var sixthNext = new SlaveNoonTwoGoodEager(ctrl);

    var firstChoice = SlaveNoonTwoOfferChoice.NOTHING;
    var secondChoice = SlaveNoonTwoOfferChoice.DECLINE;
    var thirdChoice = SlaveNoonTwoOfferChoice.INSULT;
    var fourthChoice = SlaveNoonTwoOfferChoice.ATTACK;
    var fifthChoice = SlaveNoonTwoOfferChoice.RELUCTANT;
    var sixthChoice = SlaveNoonTwoOfferChoice.EAGER;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.enslavement.noonTwo.simpleOffer = true;

        var fucked = global.kobold.history.shared.enslavement.captureFucked;
        var bindings = !global.kobold.history.shared.enslavement.nightOne.escapedBindings;
        var nameKnown = global.kobold.history.shared.enslavement.nightOne.nameStated;
        var dick = ctrl.misc.dick();
        var name = ctrl.misc.name();

        var toReturn = ``;

        if (ctrl.arrival.get() === SlaveNoonTwoArrivalChoice.LOOKOUT) {
            toReturn += `[p]
                            The big wolf struggles to stand fully upright inside of your cell,
                            his head bumping against the ceiling.
                            After grumbling something about how they should really make these carts a bit bigger, a smirk forms on his muzzle.
                            "[color=gblue]Already up and about, are you?
                            ${!bindings ? `[i]Impressive[/i].` : `[i]Good[/i].`}
                            You have a big day ahead of you.[/color]"
                        [/p]`;
            if (bindings) {
                toReturn += `
                        [p]
                            "[color=gblue]Face away for a second.
                            Let me get that rope off of you.[/color]"
                            While you don't really [i]want[/i] to [b]turn around[/b] for the fully naked lupine,
                            the premise of having your hands freed sounds too good to pass up.
                            Besides, he's clearly [i]not[/i] aroused, so you doubt he'll [i]abuse[/i] the situation.
                        [/p]
                        [p]
                            Keeping your wary eyes on the wolf for as long as you can manage, you slowly turn your back towards him.
                            With a few heavy steps, the canine approaches you from behind, the wood creaking underneath his broad footpaws.
                            He comes to a halt directly behind you, but is nice enough to leave half a foot or so in between your body and his.
                            The bandit chief reaches for your wrists, still bound behind your back, and with a simple [b]slice[/b] of a single claw,
                            he severs the cord keeping your hands together.
                        [/p]
                        [p]
                            You clutch each of your wrists in turn, rubbing them to ease the minor ropeburn.
                            After giving you a moment to enjoy your newfound freedom, the well-built man grabs your shoulder,
                            and turns your body around once more, your muzzle ending up mere inches away from his bare groin,
                            a whiff of its potent scent already reaching your nostrils.
                            Fenrir stares down at you, a lecherous look on his face.
                        [/p]`;
            } else {
                toReturn += `
                        [p]
                            "[color=gblue]So Guilliman [i]wasn't[/i] lying about you escaping your bindings.
                            Heh.
                            I assumed he caved your head in because he [b]felt[/b] like it.[/color]"
                            You frown at the thought of a remorseless bandit hitting you [i]for fun[/i].
                            "[color=gblue]Oh well.
                            It's not like he [b]needs[/b] full pay.
                            His family back home is rich as fuck.
                            Figure he's [i]rebelling[/i] against'em or something.
                            And he [b]did[/b] still damage my [i]most precious[/i] little lizard, now didn't he?[/color]"
                        [/p]
                        [p]
                            You can't help but sort of [i]agree[/i] with Fenrir on that last point.
                            There was absolutely [b]no[/b] reason for that horse to hit you.
                            Sure, you were planning to escape,
                            and you'd have bolted past him or tackled him or tried to [b]maim[/b] him if you hadn't frozen up,
                            but still.
                            What he did was plain [b]rude[/b].
                            He could have easily overpowered you [i]without[/i] using his club.
                        [/p]
                        [p]
                            "[color=gblue]Let me have a look.[/color]"
                            the canine continues, crossing the distance between you with a few heavy steps, coming to rest about half a foot away from you,
                            your muzzle mere inches away from his bare groin,
                            a whiff of its potent scent already reaching your nostrils.
                            Acting like it's no big deal, he grabs your head and tilts it downwards,
                            nearly shoving your face into his crotch in the process.
                        [/p]
                        [p]
                            "[color=gblue]It's only a small [i]bruise[/i].
                            At worst, it'll swell up a bit.
                            If any of the buyers ask, tell them that's how you were captured.[/color]"
                        [/p]
                        [p]
                            His inspection finished, the wolf lets go of your cranium.
                            You quickly pull yourself away from his loins, expecting him to depart.
                            Fenrir, however, seems to have something else in mind.
                            He stares down at you, with a lecherous look on his face.
                        [/p]`;
            }

        } else {
            toReturn += `[p]
                            The big wolf struggles to stand fully upright inside of your cell,
                            his head bumping against the ceiling.
                            He casts his gaze downwards, staring at you like a disgruntled parent would at their child.
                            After grumbling something about how they should really make these carts a bit bigger, a faint smirk forms on his muzzle.
                            "[color=gblue]Rough night, huh?[/color]"
                            A rhetorical question.
                        [/p]
                        [p]
                            With a few heavy steps, the canine approaches your downed frame, the wood creaking underneath his broad footpaws.
                            Grabbing you by the back of your neck, he hoists you upright.
                            ${bindings ? `Reaching behind you, the wolf then speedily snaps the length of rope binding your hands together.` : ``}
                            "[color=gblue]On your feet.
                            There we go.
                            You have a big day ahead of you.[/color]"
                        [/p]`;
            if (bindings) {
                toReturn += `
                        [p]
                            You clutch each of your wrists in turn, rubbing them to ease the minor ropeburn.
                            After enjoying your newfound freedom for a moment, you tilt your muzzle upwards,
                            only to find yourself mere inches away from the lupine's naked groin,
                            a whiff of its potent scent already reaching your nostrils.
                            Fenrir stares down at you, a lecherous look on his face.
                        [/p]`;
            } else {
                toReturn += `
                        [p]
                            "[color=gblue]So Guilliman [i]wasn't[/i] lying about you escaping your bindings.
                            Heh.
                            I assumed he caved your head in because he [b]felt[/b] like it.[/color]"
                            You frown at the thought of a remorseless bandit hitting you [i]for fun[/i].
                            "[color=gblue]Oh well.
                            It's not like he [b]needs[/b] full pay.
                            His family back home is rich as fuck.
                            Figure he's [i]rebelling[/i] against'em or something.
                            And he [b]did[/b] still damage my [i]most precious[/i] little lizard, now didn't he?[/color]"
                        [/p]
                        [p]
                            You can't help but sort of [i]agree[/i] with Fenrir on that last point.
                            There was absolutely [b]no[/b] reason for that horse to hit you.
                            Sure, you were planning to escape,
                            and you'd have bolted past him or tackled him or tried to [b]maim[/b] him if you hadn't frozen up,
                            but still.
                            What he did was plain [b]rude[/b].
                            He could have easily overpowered you [i]without[/i] using his club.
                        [/p]
                        [p]
                            "[color=gblue]Let me have a look.[/color]"
                            the canine continues.
                            Acting like it's no big deal, he grabs your head and tilts it downwards once more,
                            tugging you a little closer, nearly shoving your face into his crotch in the process.
                        [/p]
                        [p]
                            "[color=gblue]It's only a small [i]bruise[/i].
                            At worst, it'll swell up a bit.
                            If any of the buyers ask, tell them that's how you were captured.[/color]"
                        [/p]
                        [p]
                            His inspection finished, the wolf lets go of your cranium.
                            You quickly pull yourself away from his loins, expecting him to depart.
                            Fenrir, however, seems to have something else in mind.
                            He stares down at you, with a lecherous look on his face.
                        [/p]`;
            }
        }

        if (!nameKnown) {
            toReturn += `[p]
                            "[color=gblue]I had a few of my men ask around during the night.
                            The forest has loose lips, if you know where to pry.[/color]"
                            Huh?
                            He sent out [i]spies[/i]?
                            "[color=gblue]${name}.
                            That's your name, right?[/color]"
                            You stare up at the lupine in amazement and disbelief.
                            Barely [b]anyone[/b] around here knows your name.
                            He chuckles.
                            "[color=gblue]It fits you.[/color]"
                        [/p]`;
        }

        toReturn += `   [p]
                            The wolf moves one of his hands to his groin.
                            He boldly, brazenly and crudely cups the hefty, furred nuts that swing underneath his thick sheath,
                            propping them forwards as if to [i]entice[/i] you.
                            "[color=gblue]You've been a good ${dick ? `boy` : `girl`} so far, haven't you, ${name}?
                            At first, when I caught you, I thought you'd turn out to be a little [i]troublemaker[/i].
                            But you've proven me more than wrong.
                            I like that.[/color]"
                        [/p]
                        [p]
                            The canine licks his lips lustfully.
                            You hope he [b]isn't[/b] going to ask you to do what you [b]think[/b] he's going to ask of you.
                            "[color=gblue]From the moment ${fucked ? `I took your virginity` : `you told me you were a virgin`},
                            I [b]knew[/b] you were different from all the other kobolds.
                            Unlike the others, you are a [b]reasonable[/b] little creature.
                            You understand that not [i]all[/i] of life's problems can be solved through [b]violence[/b],
                            or by acting [b]uppity[/b] and [b]crying[/b] until you get your way.
                            I can respect that.[/color]"
                        [/p]
                        [p]
                            Oh boy.
                            You can [i]already[/i] tell where this is going, but your mind doesn't want to hear it.
                            You'd prefer to be blissfully ignorant until the words spill from Fenrir's own mouth.
                            "[color=gblue]I can make life [b]very[/b] easy for you, you know.
                            I can bring you some of the [b]good[/b] food at night,
                            I can tell the gang to [i]take it easy[/i] on you,
                            I can even make sure that [b]filthy[/b] human,
                            who I am [b]temporarily[/b] [i]indentured[/i] to,
                            won't lay even a [b]single[/b] hand on you.[/color]"
                        [/p]
                        [p]
                            A lot of benefits, but you're [b]very[/b] certain that all of this has a [b]price[/b].
                            Bandits like the wolf never hand out favors for [b]free[/b].
                            "[color=gblue]Let's face the facts here.
                            That [b]fat fuck[/b] thinks he can [i]sell[/i] you.
                            But both you and me know that there's [b]plenty[/b] of slaves to go around.
                            It's an [i]oversaturated[/i] market.[/color]"
                            Fancy words, for a brigand.
                            Then again, he [i]is[/i] their leader.
                            "[color=gblue]And, as you've no-doubt overheard, he only has two tries to auction you off.
                            After that, you'll be [b]mine[/b].[/color]"
                        [/p]
                        [p]
                            You repress the urge to tell the lupine to get to the point already.
                            It seems you've [i]placated[/i] him, and you'd hate to break his good demeanor by telling him to rush things along.
                            "[color=gblue]I won't lie.
                            You're going to be fucked, gangbanged, spitroasted and ran a train on by every single last member of my group.
                            Including the dog.
                            But that doesn't need to be a [i]bad[/i] thing.
                            If you play along, if you keep on being as nice as you've been thus far, then none of us will have any reason to treat you poorly.
                            And besides keeping us pleased, you won't have a thing in the world to worry about.
                            If you prove your worth, I might even see fit to [i]eventually[/i] consider [b]recruiting[/b] you, somewhere down the road.
                            Make you a [b]proper[/b] part of our band.[/color]"
                        [/p]
                        [p]
                            You don't get it.
                            Is Fenrir offering you a [i]job[/i]?
                            "[color=gblue]The Furskin Mountain-Crew could use a small and nimble thief like yourself.
                            And by the time we're [i]done[/i] with you, you'll be a [b]master[/b] of seduction and other [i]less common[/i] talents.[/color]"
                            You don't like the sound of that last part.
                            "[color=gblue]All I ask in return, is a simple sign of subservience.
                            You won't [i]officially[/i] be [b]my[/b] slave until the second auction fails,
                            but that doesn't mean we can't start our [i]friendship[/i] a little [i]early[/i], now does it?[/color]"
                        [/p]
                        [p]
                            You knew it.
                            The wolf may use fancy words and beat around the bush a lot, but in the end he's no better than a simple highwayman,
                            only instead of coercing money out of you, he's trying to extort your very [i]diginity[/i] itself.
                            "[color=gblue]So how about it, [b]friend[/b]?
                            All I want is a little good morning kiss.
                            Right on top of the balls that
                            ${fucked ? `squirted their contents all over your body` : `you denied release`} yesterday.[/color]"
                        [/p]
                        [p]
                            As if to accentuate his statement, the wolf taps his furred nuts,
                            rolling his hips forwards ever so slightly to hold them a little closer to your mouth.
                            Part of your mind is honestly [i]considering[/i] Fenrir's offer.
                            A life without worries [i]does[/i] seem [b]compelling[/b], to say the least.
                            And you [b]really[/b] don't want that human to get anywhere close to you.
                            But then again, you don't want to degrade yourself any more than you already have.
                            Besides, you plan on escaping long before you become the lupine's property.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled} style="width: 190px;">Do nothing</button>`;

        var tooltip = global.parser.parse(`Remain in place. Do not act. Let the canine draw his own conclusions.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 175px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice" style="width: 190px;">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled} style="width: 190px;">Decline</button>`;

        var tooltip = global.parser.parse(`You don't want to be anywhere [b]near[/b] the wolf's loins.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice" style="width: 190px;">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled} style="width: 190px;">Insult</button>`;

        var tooltip = global.parser.parse(`Who the hell does Fenrir think he is?! Tell him to get lost.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice" style="width: 190px;">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }
    /**
     * Builds and returns the choice button.
     */
    function buildFourthChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === fourthChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${fourthId}" ${disabled} style="width: 190px;">Attack</button>`;

        var tooltip = global.parser.parse(`Fight the wolf. Freedom or death!`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 145px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice" style="width: 190px;">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFifthChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === fifthChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${fifthId}" ${disabled} style="width: 190px;">Reluctantly kiss</button>`;

        var tooltip = global.parser.parse(`Ugh. Do you [i]really[/i] have to do this?`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice" style="width: 190px;">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSixthChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === sixthChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${sixthId}" ${disabled} style="width: 190px;">Eagerly kiss</button>`;

        var tooltip = global.parser.parse(`You get to kiss sweaty wolf nuts and live a life of nonstop sex? You wish you'd met him earlier!`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 225px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice" style="width: 190px;">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += `<div class="choicerow" style="margin-bottom: 10px;">`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        choice += `<div class="choicerow">`;
        choice += buildFourthChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildFifthChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSixthChoice();
        choice += `</div>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId), $("#" + fourthId), $("#" + fifthId), $("#" + sixthId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerFourthListener() {
        $("#" + fourthId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(fourthChoice);
            loadNextPart(fourthNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerFifthListener() {
        $("#" + fifthId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(fifthChoice);
            loadNextPart(fifthNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSixthListener() {
        $("#" + sixthId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(sixthChoice);
            loadNextPart(sixthNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        part += fourthNext.build();
        part += fifthNext.build();
        part += sixthNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();
        fourthNext.registerListeners();
        fifthNext.registerListeners();
        sixthNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
        registerFourthListener();
        registerFifthListener();
        registerSixthListener();
    };
}
