/**
 * Confrontation section of Varanar, Night Two.
 * @param {NightTwoController} controller The Night Two controller.
 */
function NightTwoLewdReluctant(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new NightTwoLewdReluctantContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.nightTwo.flaccidOral = true;
        var toReturn = `[p]
                            You try your hardest to look for a way out of this mess you've created, but your brain draws a blank.
                            It seems as though you've talked yourself into a corner.
                            You can simply [i]refuse[/i] to play along, but judging by the group's intense behavior,
                            you can make a pretty decent guess that things [b]won't[/b] turn out nicely if you back out now.
                            The best course of action, for now, would be to just [i]play along[/i].
                            If you do ask they ask of you, this'll all be over soon...you hope.
                        [/p]
                        [p]
                            "[color=bred]Well? Don't keep me waiting.[/color]" the half-naked human's voice snaps you back to reality.
                            He rocks his hips forwards, his unsavory groin jutting out towards you.
                            You can feel your stomach churning.
                            It's just so [b]hairy[/b] and [b]disgusting[/b].
                            You'd rather suck off a [b]horse[/b] than him.
                            You [b]really[/b] don't want to do this, but the men have left you with little choice.
                        [/p]
                        [p]
                            You sigh loudly and take a deep breath of cool, late-night air.
                            Your lungs filled with clean air, you drop to your knees, and hold your breath.
                            Closing your eyes, you lean forwards, and plant a single tiny kiss on the human's flaccid length,
                            your lips pressing against his foreskin, his pubic hair brushing against your snout.
                            "[color=bred]That's it. Keep going.[/color]"
                        [/p]
                        [p]
                            While utterly revolted by the unwashed hairs rubbing against your scales,
                            you deftly plant a second kiss atop his shrunken shaft, followed by a small lick,
                            the [b]horrid[/b] taste of the human's member only now revealed to you.
                            You barely refrain from gagging, but your wincing face clearly reveals your aversion.
                            Biting through your own reluctance, you give the man a second, a third and a fourth lick without so much as retracting your tongue,
                            your tastebuds luckily growing a little numb, sparing you from the worst of the appalling taste of the filth clinging to your tongue.
                        [/p]
                        [p]
                            Despite your best efforts, the human's member remains completely flaccid,
                            growing not even a single inch since the start of your [i]reluctant admiration[/i].
                            You pull back slightly, and cast a quizzical gaze upwards at the human.
                            "[color=bred]I...I...[/color]" he stammers, clearly lost for words.
                            "[color=bred]It's the booze, I swear![/color]"
                            The entire group bursts out into laughter.
                        [/p]
                        [p]
                            "[color=green]Jehova can't get his dick up![/color]"
                            "[color=brown]I bet your wife could use a [b]real[/b] man![/color]"
                            "[color=purple]What's the matter? Kobold not so good after all?[/color]"
                            "[color=dred]Bet he'd get hard if it were a wolfess instead![/color]"
                            Embarrassed, the exposed man quickly pulls up his pants.
                            It seems the group's attention has shifted from you to him.
                        [/p]
                        [p]
                            They bicker amongst eachother for a while, before reaching a conclusion:
                            "[color=purple]Audric wins the bet. Drinks are on Jehovah![/color]"
                            "[color=brown]To the tavern![/color]"
                            And with that, the group of drunken humans rushes off towards the brothel district,
                            leaving you on your knees in the middle of the street with your tongue still lolling out,
                            somewhat wondering what the hell just happened.
                        [/p]
                        [p]
                            You absent-mindedly retract your tongue, the dry layer of grime on top of it mixing with your saliva,
                            which seemingly rejuvinates the filth's nauseating taste, while simultaneously spreading all across your mouth.
                            You heave, retch and gag.
                            It's like you're on the verge of vomiting, without being able to hurl and get it over with already.
                            At least the humans aren't around to witness this.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = ctrl.lewdReluctant.continued() ? "disabled" : "";
        var isSelected = ctrl.lewdReluctant.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.lewdReluctant.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.appease.get() !== NightTwoLewdAppeaseChoice.RELUCTANT) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.lewdReluctant.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.appease.get() !== NightTwoLewdAppeaseChoice.RELUCTANT) {
            return;
        }

        next.registerListeners();

        if (ctrl.lewdReluctant.continued()) {
            return;
        }

        registerNextListener();
    };
}
